/*************************************************************************
 *
 * AIZO CONFIDENTIAL
 * __________________
 *
 *  [2011] - [2012] AIZO AG
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Aizo AG. The intellectual and technical concepts
 * contained herein are proprietary to Aizo AG and may be covered
 * by European and Foreign Patents, patents in process, and are
 * protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from AIZO AG.
 * Authors: Sebastian Scholz <digitalstrom@sunshine-studios.org>
 *          Andreas Brauchli <andreas.brauchli@aizo.com>
 */

var LOGFILE_NAME = "metering.log",
    l = new Logger(LOGFILE_NAME);

function addLastCalledScene(dssEvent) {
    var sceneArray = null;
    try {
        sceneArray = JSON.parse(Property.getProperty('lastCalledScenes'));
    } catch(e) {
        l.logln("WARNING: couldn't parse lastCalledScenes, discarding");
        sceneArray = [];
    }

    if (sceneArray === null) {
        sceneArray = [];
    } else if (sceneArray.length >= 50) {
        sceneArray.splice(0, 50 - sceneArray.length + 1);
    }
    sceneArray.push(dssEvent);

    Property.setProperty('lastCalledScenes', JSON.stringify(sceneArray));
    Property.store();
}

function main(raisedEvent) {
    var src,
        meter,
        sceneCall;

    if (raisedEvent.name === 'running') {
        Property.load();
        if(!Property.getNode('lastCalledScenes')) {
            Property.setProperty('lastCalledScenes', JSON.stringify([]));
            Property.setFlag('lastCalledScenes', 'ARCHIVE', true);
        }
        Property.store();

    } else if (raisedEvent.name === 'callScene') {
        src = raisedEvent.source;
        meter = src.isDevice
                    ? src.dsid
                    : parseInt(raisedEvent.parameter.originDeviceID, 10) >= 16
                        ? raisedEvent.parameter.originDeviceID
                        : undefined;
        sceneCall = {
            time: new Date(),
            zoneID: src.zoneID,
            sceneID: raisedEvent.parameter.sceneID,
            groupID: (src.isGroup ? src.groupID : undefined),
            originDSID: (src.isDevice ? src.dsid : undefined),
            meterDSID: meter ? getDevices().byDSID(meter).circuitID : undefined,
        };
        addLastCalledScene(sceneCall);

    } else if (raisedEvent.name === 'deviceSensorEvent') {
        src = getDevices().byDSID(raisedEvent.source.dsid);
        sceneCall = {
            time: new Date(),
            zoneID: src.zoneID,
            originDSID: raisedEvent.source.dsid,
            meterDSID: src.circuitID,
            eventName: raisedEvent.parameter.sensorEvent
        };
        addLastCalledScene(sceneCall);
    }
}

main(raisedEvent);
